#ifndef ADVANCEDDIALOG_H
#define ADVANCEDDIALOG_H

#include <QWidget>
#include <QLabel>
#include <QComboBox>
#include <QPushButton>
#include <QStandardItemModel>
#include <QGSettings>
#include <QGridLayout>
#include <QTextEdit>

class AdvancedDialog : public QWidget
{
    Q_OBJECT

public:
    explicit AdvancedDialog(QWidget *parent = nullptr);
    ~AdvancedDialog();

private:
    void setWidgetUi();
    void setWidgetContent();
    void setConnect();
    void comboxTextChangedSlot(const QString& text);
    void styleSettingChangeSlot(const QString& key);
    void monoSettingChangeSlot(const QString& key);
    QStringList splitFontNameSize(QString value);

private slots:
    void onPushButtonClicked();

private:
    QPushButton *m_okButton;
    QPushButton *m_cancelButton;
    QStringList m_monospacefontStrList;
    QLabel* m_title = nullptr;
    QTextEdit* m_desc = nullptr;
    QComboBox* m_monoCombox = nullptr;
    QStandardItemModel* m_monoModel = nullptr;
    QGSettings* m_ifsettings = nullptr;
    QGSettings* m_gnomeSettings = nullptr;
    QGSettings* m_stylesettings = nullptr;
    QPushButton* m_confirmButton = nullptr;
    QGridLayout* m_gridLayout = nullptr;
    QVBoxLayout* m_vGridLayout = nullptr;
};

#endif // ADVANCEDDIALOG_H
